import { IPathnameParams } from '@do-while-for-each/common';
import { MatchFunction } from 'path-to-regexp';
import { ICustomTo, IEntry } from './contract';
/**
 * The Entry is an instruction on what to do when matching for this segment of the pathname:
 *
 *   {
 *     segment,
 *
 *     component?,
 *     redirectTo?,
 *     customTo?,
 *     action?,
 *     children?,
 *
 *     canActivate?, canDeactivate?,
 *
 *     note?, name?
 *   }
 *
 */
export declare class Entry {
    orig: IEntry;
    parent?: Entry | undefined;
    hasResult: boolean;
    resultIsOnlyChildren: boolean;
    pathTemplate: string;
    match: MatchFunction<IPathnameParams>;
    get segment(): string;
    isWildcard: boolean;
    isParam: boolean;
    isSimpleSegment: boolean;
    component?: any;
    redirectTo?: string;
    customTo?: IEntry['customTo'];
    action?: any;
    children?: Entry[];
    canActivate?: any;
    canDeactivate?: any;
    note?: any;
    name?: string;
    constructor(orig: IEntry, parent?: Entry | undefined);
    flat(): Entry[];
    clone(): Entry;
    cloneFull(): Entry;
    static cloneOrig(orig: IEntry, { skipChildren }?: {
        skipChildren: boolean;
    }): IEntry;
    static normalizePathTemplate(orig: IEntry, parent?: Entry): string;
    static normalizeRedirectTo(redirectTo?: string): string | undefined;
    static normalizeCustomTo(customTo?: ICustomTo): ICustomTo | undefined;
    static normalizeChildren({ children }: IEntry, parent: Entry): Entry[] | undefined;
    static cloneObj(data?: any): any;
    static flat(entry: Entry): Entry[];
    static hasResult(orig: IEntry): boolean;
    static resultIsOnlyChildren(orig: IEntry): boolean;
    static isMultiResult(orig: IEntry): boolean;
    static of(orig: IEntry, parent?: Entry): Entry;
}
//# sourceMappingURL=entry.d.ts.map